package aoc

import "testing"

func TestDay03Example1(t *testing.T) {
	data := []string{"..##.......", "#...#...#..", ".#....#..#.", "..#.#...#.#", ".#...##..#.", "..#.##.....", ".#.#.#....#", ".#........#", "#.##...#...", "#...##....#", ".#..#...#.#"}
	answer := day03solve1(data, len(data), 1, 3)

	if answer != 7 {
		t.Errorf("Day03Example1 Answer found was %d, expected was 7", answer)
	}
}

func TestDay03Example2(t *testing.T) {
	data := []string{"..##.........##.........##.........##.........##.........##.......", "#...#...#..#...#...#..#...#...#..#...#...#..#...#...#..#...#...#..", ".#....#..#..#....#..#..#....#..#..#....#..#..#....#..#..#....#..#.", "..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#", ".#...##..#..#...##..#..#...##..#..#...##..#..#...##..#..#...##..#.", "..#.##.......#.##.......#.##.......#.##.......#.##.......#.##.....", ".#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#", ".#........#.#........#.#........#.#........#.#........#.#........#", "#.##...#...#.##...#...#.##...#...#.##...#...#.##...#...#.##...#...", "#...##....##...##....##...##....##...##....##...##....##...##....#", ".#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#"}
	answer := day03solve1(data, len(data), 1, 3)

	if answer != 7 {
		t.Errorf("Day03Example2 Answer found was %d, expected was 7", answer)
	}
}

func TestDay03Part1(t *testing.T) {
	data, count := loadData("../../../data/day03.dat")

	answer := day03solve1(data, count, 1, 3)

	if answer != 265 {
		t.Errorf("Day03Part1: Answer found was %d, expected was 265", answer)
	}
}

func TestDay03Example3(t *testing.T) {
	data := []string{"..##.........##.........##.........##.........##.........##.......", "#...#...#..#...#...#..#...#...#..#...#...#..#...#...#..#...#...#..", ".#....#..#..#....#..#..#....#..#..#....#..#..#....#..#..#....#..#.", "..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#..#.#...#.#", ".#...##..#..#...##..#..#...##..#..#...##..#..#...##..#..#...##..#.", "..#.##.......#.##.......#.##.......#.##.......#.##.......#.##.....", ".#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#.#.#.#....#", ".#........#.#........#.#........#.#........#.#........#.#........#", "#.##...#...#.##...#...#.##...#...#.##...#...#.##...#...#.##...#...", "#...##....##...##....##...##....##...##....##...##....##...##....#", ".#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#.#..#...#.#"}
	answer := day03solve2(data, len(data))

	if answer != 336 {
		t.Errorf("Day03Example3 Answer found was %d, expected was 336", answer)
	}
}

func TestDay03Part2(t *testing.T) {
	data, count := loadData("../../../data/day03.dat")

	answer := day03solve2(data, count)

	if answer != 3154761400 {
		t.Errorf("Day03Part2: Answer found was %d, expected was 3154761400", answer)
	}
}
